# coding: utf-8

"""
    Cakemail API

    The Cakemail API exposes multiple APIs including Authentication, Marketing, Contact, Transactional, Analytic, Content, Account and Partner.  # noqa: E501

    The version of the OpenAPI document: 1.6.4
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from cakemail_openapi.configuration import Configuration


class CreateWebhook(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'event': 'WebhookEvent',
        'url': 'str',
        'rate_limit': 'int',
        'rate_limit_period': 'RateLimitPeriod'
    }

    attribute_map = {
        'event': 'event',
        'url': 'url',
        'rate_limit': 'rate_limit',
        'rate_limit_period': 'rate_limit_period'
    }

    def __init__(self, event=None, url=None, rate_limit=100, rate_limit_period=None, local_vars_configuration=None):  # noqa: E501
        """CreateWebhook - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._event = None
        self._url = None
        self._rate_limit = None
        self._rate_limit_period = None
        self.discriminator = None

        self.event = event
        self.url = url
        if rate_limit is not None:
            self.rate_limit = rate_limit
        if rate_limit_period is not None:
            self.rate_limit_period = rate_limit_period

    @property
    def event(self):
        """Gets the event of this CreateWebhook.  # noqa: E501


        :return: The event of this CreateWebhook.  # noqa: E501
        :rtype: WebhookEvent
        """
        return self._event

    @event.setter
    def event(self, event):
        """Sets the event of this CreateWebhook.


        :param event: The event of this CreateWebhook.  # noqa: E501
        :type: WebhookEvent
        """
        if self.local_vars_configuration.client_side_validation and event is None:  # noqa: E501
            raise ValueError("Invalid value for `event`, must not be `None`")  # noqa: E501

        self._event = event

    @property
    def url(self):
        """Gets the url of this CreateWebhook.  # noqa: E501


        :return: The url of this CreateWebhook.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this CreateWebhook.


        :param url: The url of this CreateWebhook.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and url is None:  # noqa: E501
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                url is not None and len(url) > 2083):
            raise ValueError("Invalid value for `url`, length must be less than or equal to `2083`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                url is not None and len(url) < 1):
            raise ValueError("Invalid value for `url`, length must be greater than or equal to `1`")  # noqa: E501

        self._url = url

    @property
    def rate_limit(self):
        """Gets the rate_limit of this CreateWebhook.  # noqa: E501


        :return: The rate_limit of this CreateWebhook.  # noqa: E501
        :rtype: int
        """
        return self._rate_limit

    @rate_limit.setter
    def rate_limit(self, rate_limit):
        """Sets the rate_limit of this CreateWebhook.


        :param rate_limit: The rate_limit of this CreateWebhook.  # noqa: E501
        :type: int
        """

        self._rate_limit = rate_limit

    @property
    def rate_limit_period(self):
        """Gets the rate_limit_period of this CreateWebhook.  # noqa: E501


        :return: The rate_limit_period of this CreateWebhook.  # noqa: E501
        :rtype: RateLimitPeriod
        """
        return self._rate_limit_period

    @rate_limit_period.setter
    def rate_limit_period(self, rate_limit_period):
        """Sets the rate_limit_period of this CreateWebhook.


        :param rate_limit_period: The rate_limit_period of this CreateWebhook.  # noqa: E501
        :type: RateLimitPeriod
        """

        self._rate_limit_period = rate_limit_period

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateWebhook):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateWebhook):
            return True

        return self.to_dict() != other.to_dict()
